%ext ck6
%version 1.4

###Load the custom maps and graphics###
%egahead EGAHEAD.CK6
%gamemaps editmaps.ck6
%maphead maphead.ck6
%patchfile $25212 keen6.tli
%patchfile $1fca7 ck6load.bin 

#Skip creature question 
%patch $1CC88 $90 $90


#Music
%patch $3103E $05 $00 $03 $00 $08 $00 $07 $00 $08 $00 $07 $00 $03 $00 $02 $00 $04 $00 $02 $00 $04 $00 $07 $00 $01 $00 $06 $00 $01 $00 $06 $00 $02 $00 $00 $00 $03 $00 



%patch $563F $03 $00 #Star wars text

%patch $E33C $0F $00 #Molly ending (Faster)


#To patch AUDIODCT.CK4:
%patchfile $36EEE "AUDIODCT.CK6"

#To patch AUDIOHED.CK4:
%patchfile $20C50 "AUDIOHED.CK6"

###Nospike###

#nospike doesn't die when falls
%patch $11035 $2460W 
#K1n9_Duk3 fix: don't change obclass on landing
%patch $1104D $90 $90 $90 $90

#Nospike takes l16 shots 
%patch $10D35 $10 $00 

#Nospike charges instead of standing still
%patch $33190 $012FW #Facing left sprite: 257
%patch $33192 $012BW #Facing right sprite: 253
%patch $3319A $0004W #Anim speed
%patch $331AC $24F6W #Go to


#Shot Nospike, when tocuhed by Keen, does the Molly thing
%patch $1256C $02 $75 $30 $C7 $06 $AC $75 #Ceilick when hit by Keen (2, shot = 3)
              $0C $00 $5F $5E $5D $CB     #Goes to Molly
#K1n9_Duk3 TODO: how was this SUPPOSED to work?

%patch $3332A $11CF086CRL #Shot Nospike uses Ceilick death
%patch $3406A $00000000RL #Ceilick laughing has no death
%patch $34088 $00000000RL #Ceilick
%patch $340A6 $00000000RL #Ceilick

%patch $340C4 $00000000RL #Ceilick
%patch $340E2 $00000000RL #Ceilick
%patch $34100 $00000000RL #Ceilick
%patch $3411E $00000000RL #Ceilick
%patch $3413C $00000000RL #Ceilick
%patch $3415A $00000000RL #Ceilick

#Note: the above patch seems to make shooting the Ceilick crash the game.


###Orbatrix###

#Orbatrix Gives Red Key on Touch
%patch $114F2 $05 $00 #Trix propp, 13

#Stop Trix balling:
%patch $1159F $04 $28

#Orb tries to keep away from Keen:
%patch $1158B $FF $FF
%patch $11586 $01 $00

%patch $33522 $0020W $0000W #Floating h\v speed 
%patch $33540 $0020W $0000W #Floating h\v speed 

#Bullets pass through the Orbatrix
#SIDE EFFECT: Doesn't stop moving when shot at

#Floating l/r
%patch $3352A $08F417EERL #Kill Keen
%patch $33548 $08F417EERL #Kill Keen

#Floating u/d
%patch $335FC $08F417EERL #Kill Keen
%patch $3361A $08F417EERL #Kill Keen
%patch $33638 $08F417EERL #Kill Keen
%patch $33656 $08F417EERL #Kill Keen


###Blooguard###

#speed
%patch $32CB8 $0080W $0000W #Walking h\v speed 1
%patch $32CD6 $0080W $0000W #Walking h\v speed 2
%patch $32CF4 $0080W $0000W #Walking h\v speed 3
%patch $32D12 $0080W $0000W #Walking h\v speed 4

#Chance of clubbing ground (When Keen around)
%patch $109BD $20 $00
#Blooguard club ground wherever Keen is
%patch $109B5 $90 $90

###Gik###

#Gik jump (And slide):
%patch $111DE $FF $FF #Left sp
%patch $111E5 $01 $00 #Right sp
%patch $111EA $C4 $FF #Height

#Number of tiles close to Keen before Gik jumps:
%patch $111C8 $02 #Right: 2
%patch $111C2 $FD #Left: -2

#Number of tiles close to Keen before Gik jumps Original:
#%patch $111C8 $07 #Right: 7
#%patch $111C2 $F9 #Left: -7

#Gik don't attack Keen he's riding on you distance:
%patch $111D4 $01 #Right: 1
%patch $111CE $FF #Left: -1

#Make jumping Gik kill Keen:
%patch $3339E $0A13W $10CCRW
# K1n9_Duk3 note: this effectively makes the Gik skip the jump state (which
# just pushes Keen) after one frame and flow into the sliding state (which
# kills Keen). The jump state is where the Gik replacement opens its mouth.



###Blorb###


#blorb speed
#Row 298  $3164
%patch $33E9E $0014W #Anim speed
%patch $33EA0 $0010W #H move
%patch $33EA2 $0015W #V move

%patch $33EBC $0014W #Anim speed
%patch $33EBE $0010W #H move
%patch $33EC0 $0020W #V move

%patch $33EDA $0014W #Anim speed
%patch $33EDC $0010W #H move
%patch $33EDE $0010W #V move

#EFFECT: Shots collide with Blorb
%patch $33EA8 $11CF0306RL #Bobba
%patch $33EC6 $11CF0306RL #Bobba
%patch $33EE4 $11CF0306RL #Bobba

###Babobba####

#Babobba doesn't nap:
%patch $1217C $2F84W #Bab nap

#Change Babobba shooting anims:
#WARNING! UNCACHED SPRITE ERROR IF BIP-BOARD NOT ALSO IN LEVEL!!!
%patch $33CD2 $01AFW #Facing left sprite: 385
%patch $33CD4 $01B0W #Facing right sprite: 386 


###Blooglet###

#Red speed:
%patch $32DC6 $0080W $0000W #Walking h\v speed 
%patch $32DE4 $0080W $0000W #Walking h\v speed 
%patch $32E02 $0080W $0000W #Walking h\v speed 
%patch $32E20 $0080W $0000W #Walking h\v speed 

#Yellow
%patch $32E5C $0080W $0000W #Walking h\v speed 
%patch $32E7A $0080W $0000W #Walking h\v speed 
%patch $32E98 $0080W $0000W #Walking h\v speed 
%patch $32EB6 $0080W $0000W #Walking h\v speed 

#Blue
%patch $32EF2 $0080W $0000W #Walking h\v speed 
%patch $32F10 $0080W $0000W #Walking h\v speed 
%patch $32F2E $0080W $0000W #Walking h\v speed 
%patch $32F4C $0080W $0000W #Walking h\v speed 

#Green
%patch $32F88 $0044W $0000W #Walking h\v speed 
%patch $32FA6 $0044W $0000W #Walking h\v speed 
%patch $32FC4 $0044W $0000W #Walking h\v speed 
%patch $32FE2 $0044W $0000W #Walking h\v speed 


###Fleex####

#Fleex strength
%patch $11D6F $02 $00

#Fleex never searches
#%patch $11D80 $24


#Fleex looking around times:
%patch $33A66 $0010W        #Animation speed
%patch $33A84 $0010W        #Animation speed



###Flect###

#Flect kills Keen instead of pushing:
%patch $11C05 $02         #Push  [Keen]
%patch $11C0B $0AA213CARL #What to do [Kill Keen]

#Flect Speed
%patch $3391E $0060 $0000 #Walking h\v speed 
%patch $3393C $0060 $0000 #Walking h\v speed 
%patch $3395A $0060 $0000 #Walking h\v speed 
%patch $33978 $0060 $0000 #Walking h\v speed 


###Bipship####

#No bip spawned when bipship crashes
#%patch $11AAB $9090W

###Bip###

#Bip can kill Keen, is shootable to give squashed bip:
#%patch $1178C $55 $8B $EC $56 $8B $76 $08 $83 $3C $02 $75 $08 $9A $CA $13 $0AA2RW
#                  $5E $5D $CB $83 $3C $03 $75 $10 $B8 $3E $2A $50 $56 $FF $76
#              $06 $9A $22 $17 $08F4RW $83 $C4 $06 $5E $5D $CB


###Bobba###

#Give Bobba two extra shooting frames:
#381-382 shoot left, 383-384 shoot right
%patch $11F45 $3452W #When shooting, use frame 2, 2->3->1
#K1n9_Duk3 fix: the old patch used the Bobba contact function ($11CF0306RL)
#as a think function here. Replaced it with NULL ($00000000L)
%patch $33B10 $01ABW $01ADW  $0000W $0000W  $0000W $0028W  $0000W $0000W
              $00000000L     $0306W $11CFRW $180AW $08F4RW $2D86W
%patch $34182 $01ACW $01AEW  $0000W $0000W  $0000W $0028W  $0000W $0000W
              $00000000L     $0306W $11CFRW $180AW $08F4RW $3470W
%patch $341A0 $0192W $0195W  $0000W $0000W  $0000W $0028W  $0000W $0000W
              $00000000L     $0306W $11CFRW $180AW $08F4RW $2DE0W



#Bullet 1:
%patch $33B38 $0008 #Anim speed


###Winng the Game (Molly)###



#Stupendous Sandwich of Chungella IV:
%patch $325B6 "A power source! I " $0A
              "should bring it to" $0A
              "the ship!" $0A $00 #might be a space too long

#Grabbiter:
%patch $3301A "       " $0A
          $22 "Don't stop now! " $0A
              "Go find the battery" $0A
              "so I... WE can  " $0A
              " get off this planet!" $22 $00

%patch $F54E  $0A $00 #Store this bitmap (35 - 6 = 29)
%patch $F57B  $0A $00 #Show this bitmap (35 - 6 = 29)

%patch $F600  $0A $00 #Store this bitmap (35 - 6 = 29)
%patch $F621  $0A $00 #Show this bitmap (35 - 6 = 29)


%patch $33071 "The Dude grabs the " $0A
              "battery from Keen.    " $0A
          $22 "Haha! Now I can leave" $0A
              "and you'll be left  " $0A
              "behind! So long  " $0A
              "sucker!" $22 "    " $00

#Grabbiter animation speed
%patch $327CA $0020W #Ravening
%patch $327E8 $0090W	#K1n9_Duk3 fix: the offset was wrong ($327EB)

#Rope and grappling hook
%patch $325E7 "Wow! A lantern!" $0A
              "I should hang  " $0A
              "on to this!     " $0A $00

#Cliff:
%patch $33139 "It's too dark in " $0A
              "there! I need a  " $0A
              "lantern.           " $0A $00

#Rocket passcard
%patch $3261A "What's this? It   " $0A
              "looks like a  " $0A
              "key-card.  I should  " $0A
              "take this with me  " $0A
              "just in case!      " $0A $00

%patch $330EB "Hmm, I need some kind" $0A
              "of pass card to" $0A
              "enter.  " $0A
              "                 " $0A
              "          " $00 

%patch $30F95 "  Exit to Calidune   " $00 
%patch $312F1 "KEYS" $00 
              "AMMO" $00 
              "KEENS" $00 
              "H20  " $00

##Level Names##
#world map
%patch $1EF40 "   Calidune    " $00
%patch $1F110 "Keen wanders" $0A
              "  across Calidune " $00
#Level 1
%level.name 1 The Dusty Dunes
%patch $1F130 "Keen treads up the" $0A
              "Dusty Dunes" $0A
              "        " $00
#Level 2
%patch $1EF70 "The Arid Hills " $00
%patch $1F160 "Keen crawls down the" $0A
               "Arid Hills" $00
#Level 3
%level.name 3 Red Rock Mountain
%patch $1F190 "Keen clambers up" $0A
               "Red Rock Mountain" $00
#Level 4 name
%level.name 4 Tumbleworm Alley
%patch $1F1C0 "Keen blows through" $0A
              "Tumbleworm Alley" $00
#Level 5 name
%level.name 5 Cobrit Pit
%patch $1F1F0 "Keen dives into" $0A
              "the Cobrit Pit" $00
              "           " $00
#Level 6 name
%patch $1EFD0 "Cactus Forest" $00
%patch $1F220 "Keen squirms through" $0A
              "the Cactus Forest" $00

#Level 7 name
%patch $1EFF0 "Lava Lake" $00
%patch $1F250 "Keen crosses" $0A
              "the Lava Lake" $00
#Level 8 name
%patch $1F000 "The Molten Passage" $00
%patch $1F270 "Keen sweats through" $0A
              "the Molten Passage" $00
#Level 9 name
%patch $1F020 "Rocky Road" $00
%patch $1F2A0 "Keen trips along" $0A
              "the Rocky Road" $00
#Level 10 name
%patch $1F030 "Stalagmite Peak" $00

%patch $1F2D0 "Keen scales" $0A
              "Stalagmite Peak" $00
#Level 11 name
%patch $1F040 "The Boulder" $00

%patch $1F300 "Keen bumps into" $0A
              "The Boulder" $00
#Level 12 name
%patch $1F050 "Hydro Palace" $00

%patch $1F350 "Keen blasts into the" $0A
              "Hydro Palace" $00
#Level 13 name
%patch $1F070 "Hydro Corp 1" $00

%patch $1F380 "Keen ducks into " $0A
              "Hydro Corp 1" $00
#Level 14 name
%patch $1F090 "Hydro Factory" $00

%patch $1F3C0 "Keen searches the " $0A
              "Hydro Factory" $00
#Level 15 name
%patch $1F0B0 "Hydro Corp 2" $00

%patch $1F400 "Keen investigates" $0A
              "Hydro Corp 2" $00
#Level 16 name
%patch $1F0D0 "Devil's Cavern" $00

%patch $1F440 "Keen descends the" $0A
              "Devil's Cavern" $00
#Level 17 name
%patch $1F0E0 "Battle for the Ship" $00

%patch $1F470 "Keen battles for the ship" $00


###star wars text story###
#Patch the commander Keen 6  'star wars text' story:
%patchfile $1ED50 "STORY.ck6"

###Satelite###
#Satelite no longer appears in front of Keen
%patch $FD58  $00 $00 #Satelite on map

#Laughing Ceilick has no collision
#SIDE EFFECT: He's immortal
%patch $3406A $00000000L  #Nothing
%patch $34088 $00000000L  #Nothing
%patch $340A6 $00000000L  #Nothing
%patch $340C4 $00000000L  #Nothing
%patch $340E2 $00000000L  #Nothing
%patch $34100 $00000000L  #Nothing
%patch $3411E $00000000L  #Nothing
%patch $3413C $00000000L  #Nothing
%patch $3415A $00000000L  #Nothing
#Touching stunned boss wins game:
%patch $1256A $90 $90     #Always React


#Changed bullet still kills things:
#%patch $122BD $04         #Babobba
#%patch $122DC $04        
#%patch $11AC6 $04         #Bipship
#%patch $108D8 $04         #Bloog
#%patch $10A0E $04         #Blooguard
#%patch $12011 $04         #Bobba
#%patch $11C18 $04         #Flect
#%patch $11DE4 $04         #Fleex
#%patch $10E75 $04         #Nospike
#%patch $115AE $04         #Orbatrix
#%patch $1171C $04 




#%patch $D83F  $04 $00 #Keen's shot
#%patch $121AB $07 $00 #Babobba spark
#%patch $11918 $07 $00 #Bipship shot

#Terminator text palette: 
%patch $30E7C $00 $01 $01 $11 $03 $03 $03 $03     #Dark colors 
              $1E $1E $1E $1E $06 $06 $06 $06 $00 #Light colors (and border color) 
#Terminator text palette 2, screen moves out: 
%patch $30E8D $00 $01 $01 $01 $01 $01 $01 $01     #Dark colors 
              $11 $11 $11 $11 $13 $13 $13 $01 $00 #Light colors (and border color)



################################################################################
# Version Info
################################################################################

%patch $20BD1	# Keen 6 startup screen
	"U" $1B
	"n" $1B
	"o" $1B
	"f" $1B
	"f" $1B
	"i" $1B
	"c" $1B
	"i" $1B
	"a" $1B
	"l" $1B
	" " $1B
	"B" $1B
	"u" $1B
	"g" $1B
	"f" $1B
	"i" $1B
	"x" $1B
	" " $1B
	"R" $1B
	"e" $1B
	"l" $1B
	"e" $1B
	"a" $1B
	"s" $1B
	"e" $1B
	" " $1B
	"(" $1B
	"2" $1B
	"0" $1B
	"2" $1B
	"0" $1B
	"-" $1B
	"0" $1B
	"9" $1B
	"-" $1B
	"2" $1B
	"2" $1B
	")" $1B


######################
# Additional Changes #
######################

# keep showing the lamp in the inventory after it was used for the first time:
%patch $7CA0 $00 $74


#######################
# Additional Bugfixes #
#######################

# Only remove level entrances for finished levels on world map
# (leave elevator and teleporter coordinates intact):
%patch $5EDB
	$80 $7E $FB $C0		#	cmp	byte ptr [bp-5], 0C0h
	$75 $0D			#	jne	check_barrier
	$90 $90 $90 $90		#	nop nop nop nop

%patch $5EED $90 $80 $7E $FB $D0	# modified barrier check
%patch $5F04 $90 $80 $7E $FB $F0	# modified flag check


################################################################################
# Customized Screen Update Code For KEEN6 v1.4 (EGA)
# Copyright (c) 2019 K1n9_Duk3
#
# This software is provided 'as-is', without any express or implied warranty. In
# no event will the authors be held liable for any damages arising from the use
# of this software.
#
# Permission is granted to anyone to use this software for any purpose, including
# commercial applications, and to alter it and redistribute it freely, subject to
# the following restrictions:
#
# 1. The origin of this software must not be misrepresented; you must not claim
#    that you wrote the original software. If you use this software in a product,
#    an acknowledgment in the product documentation would be appreciated but is
#    not required.
#
# 2. Altered source versions must be plainly marked as such, and must not be
#    misrepresented as being the original software.
#
# 3. This notice may not be removed or altered from any source distribution.
################################################################################

#replace the v1.4 delay code with my custom VW_SetScreen code
#(my VW_SetScreen is bigger than the one in v1.4)
%patch $1E713
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$BA $03DAw		#	mov	dx, 3DAh
	$FA			#	cli
				#@l1:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$74 $FB			#	jz	@l1
				#@l2:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$75 $FB			#	jnz	@l2
	$8B $4E $06		#	mov	cx, [bp+arg_start]
	$BA $03D4w		#	mov	dx, 3D4h
	$B0 $0C			#	mov	al, 0Ch
	$EE			#	out	dx, al
	$42			#	inc	dx
	$8A $C5			#	mov	al, ch
	$EE			#	out	dx, al
	$4A			#	dec	dx
	$B0 $0D			#	mov	al, 0Dh
	$EE			#	out	dx, al
	$8A $C1			#	mov	al, cl
	$42			#	inc	dx
	$EE			#	out	dx, al
	$F7 $06 $754Cw $0001w	#	test	fixjerky, 1
	$74 $03			#	jz	@l3
	$E8 $0053w		#	call	WaitVBL
				#@l3:
	$F7 $06 $761Aw $0001w	#	test	nopan, 1
	$75 $0C			#	jnz	l4
	$BA $03C0w		#	mov	dx, 3C0h
	$B0 $33			#	mov	al, 33h
	$EE			#	out	dx, al
	$EB $00			#	jmp	$
	$8A $46 $08		#	mov	al, [bp+arg_pan]
	$EE			#	out	dx, al
				#@l4:
	$F7 $06 $754Cw $0001w	#	test	fixjerky, 1
	$75 $03			#	jnz	@l5
	$E8 $0034w		#	call	WaitVBL
				#@l5:
	$FB			#	sti
	$5D			#	pop	bp
	$CB			#	retf

#replace the start of VW_SetScreen with a jump into my new code (see above):
%patch $1E794
	$E9 $FF7Cw

#and overwrite the rest of the old VW_SetScreen code with my WaitVBL code:
	$8B $1E $A6CBw		#	mov	bx, word ptr TimeCount
	$BA $03DAw		#	mov	dx, 3DAh
				#@wait:	
	$FB			#	sti
	$EB $00			#	jmp	short $
	$FA			#	cli
	$EC			#	in	al, dx
	$A8 $08			#	test	al, 8
	$75 $0A			#	jnz	@done
	$A1 $A6CBw		#	mov	ax, word ptr TimeCount
	$2B $C3			#	sub	ax, bx
	$3D $0001w		#	cmp	ax, 1
	$76 $ED			#	jbe	@wait
				#@done:
	$C3			#	retn

################################################################################
# End of Customized Screen Update Code
################################################################################


##############################
# Load Audio Chunks Directly #
##############################

# This patch forces the game to load the audio data directly from the file into
# the final buffer without doing any Huffman decompression. This requires the
# AUDIO.CK6 file to be compressed with a "dummy" Huffman dictionary.
#
# Without this code, the game would load the "compressed" data into a temporary
# buffer and then decompress it into the final buffer. That means the memory
# requirements for music are more than TWICE(!) the size of the IMF song.

%patch $12F97
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$FF $76	$FE		#	push	bp+var_2
	$FF $76 $FC		#	push	bp+var_4
	$FF $36 $CD67w		#	push	audiohandle
	$9A $00001BC9rl		#	call	_lseek
	$83 $C4 $08		#	add	sp, 8
	$B8 $0004w		#	mov	ax, 4
	$50			#	push	ax
	$B8 $CD5Fw		#	mov	ax, offset chunkexplen
	$50			#	push	ax
	$FF $36 $CD67w		#	push	audiohandle
	$9A $00001F10rl		#	call	_read
	$83 $C4 $06		#	add	sp, 6
	$FF $36 $CD61w		#	push	word ptr chunkexplen+2
	$FF $36 $CD5Fw		#	push	word ptr chunkexplen
	$8B $C6			#	mov	ax, si
	$D1 $E0			#	shl	ax, 1
	$05 $C8EBw		#	add	ax, offset audiosegs
	$50			#	push	ax
	$9A $15110713rl		#	call	MM_GetPtr
	$83 $C4 $06		#	add	sp, 6
	$83 $3E $A97Dw $00	#	cmp	mmerror, 0
	$75 $1E			#	jnz	done
	$FF $36 $CD61w		#	push	word ptr chunkexplen+2
	$FF $36 $CD5Fw		#	push	word ptr chunkexplen
	$8B $DE			#	mov	bx, si
	$D1 $E3			#	shl	bx, 1
	$FF $B7 $C8EBw		#	push	audiosegs[bx]
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$FF $36 $CD67w		#	push	audiohandle
	$0E			#	push	cs
	$E8 $F68Bw		#	call	near ptr CA_FarRead
	$83 $C4 $0A		#	add	sp, 10
				#done:
	$5E			#	pop	si
	$8B $E5			#	mov	sp, bp
	$5D			#	pop	bp
	$CB			#	retf

# This leaves 183 bytes unused at $13002 to $130B8 (inclusive)

# With this code, the huffman tree for the audio data is no longer needed,
# so let's prevent the engine from "optimizing" the huffman tree. This frees
# up 1024 bytes in the data segment, great for adding new (near) strings or
# new object state definitions.

# Free up 1024 bytes at $36EEE (dseg:61BE):
%patch $12EA4 $EB $0F


########################################################
# Free Tile And Sprite Graphics Before Loading A Level #
########################################################

#Free sprites and tiles before loading a level
%patch $5FAD
	$74 $0A			#	jz	no_demo
	$C7 $06 $6F6Cw $0002w	#	mov	gamestate_difficulty, 2
	$33 $C0			#	xor	ax, ax
	$EB $03			#	jmp	init_rndt
				#no_demo:
	$B8 $0001w		#	mov	ax, 1
				#init_rndt:
	$50			#	push	ax
	$9A $1CF3000Crl		#	call	US_InitRndT
	$58			#	pop	ax
	$9A $05A1000Arl		#	call	FreeUpMemory
	$90 $90 $90 $90 $90 $90	#	(6x nop)

#Don't free the paddle war sprites (in case loading a game fails)
%patch $5A1F $0033w		# default: $002Ew


##################
# Memory Related #
##################

# Fix error in XMS size calculation
%patch $152F3
	$BB $0010w		#	mov	bx, 16
	$F7 $E3			#	mul	bx
	$01 $06 $A1A5w		#	add	..., ax
	$11 $16 $A1A7w		#	adc	..., dx


# Lock text buffers to avoid "PageLayout: Text not headed with ^P" error

# CacheAndLock routine (returns grsegs offset in AX):
%patch $18403
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$57			#	push	di
	$8B $7E $06		#	mov	di, [bp+arg_0]
	$57			#	push	di
	$9A $125A1108rl		#	call	CA_CacheGrChunk
	$58			#	pop	ax
	$B8 $0001w		#	mov	ax, 1
	$50			#	push	ax
	$D1 $E7			#	shl	di, 1
	$81 $C7 $7629w		#	add	di, offset grsegs
	$57			#	push	di
	$9A $15110AD6rl		#	call	MM_SetLock
	$83 $C4 $04		#	add	sp, 4
	$8B $C7			#	mov	ax, di
	$5F			#	pop	di
	$5D			#	pop	bp
	$CB			#	retf
# Note: this overwrites the unused SDL_TimingService code (2 bytes left unused)

# Use CacheAndLock instead of CA_CacheGrChunk to cache the text chunks
%patch $E321 $183B0053rl	# for the ending text


# Make CA_UpLevel flow into CA_ClearMarks so we don't load more	than we need
%patch $13A7C $EB $30


###################
# Fix Engine Bugs #
###################

# Avoid crashing when trying to draw characters that don't exist in the font:
%patch $36EE2 $08C5w

# Make VW_ClearVideo abort if screenseg is NULL:
%patch $1D29D
	$83 $3E $A93Cw $00	#	cmp	screenseg, 0
	$74 $26			#	jz	done
	$B8 $0000w		#	mov	ax, 0
#this patch overwrites some code that effectively sets AX to 0, that's why the
#new code also sets AX to 0 at the end


%end